--*****************************************************************************
-- Datei            : abwesenheitsmarkierung.ads
-- Project          : Terminkalender  ( FaPra WS1995/96 Gruppe 5 )
-- Version          : 1
-- Autor            : Peter Vollmer
-- Hardware         : DEC-Workstation 3100
-- Betriebssystem   : Ultrix Version 4.3
-- Sprache          : Ada95
-- Compiler         : gnat Version 2.07
-- Erstellungsdatum : 04.01.96
-------------------------------------------------------------------------------
-- Aufgabe          : Stellt Funktionen fuer den Umgang mit der Abwesenheits-
--		      markierung zur Verfuegung.	
-- Anwendung        :
-- Einschraenkung   :
-- Fehlerbehandlung :
--*****************************************************************************
with Kalender;use Kalender;
with Sequential_Io;

package Abwesenheitsmarkierung is

type Abwesenheits_Typ is (Keine,Urlaub,Tagung,Dienstreise);
type Abwesenheitsarray_Typ is array(Kalender.Jahr_Typ'Range,
				    Kalender.Monat_Typ'Range,
				    Kalender.Tag_Typ'Range) 
  of Abwesenheits_Typ;




-------------------------------------------------------------------------------
function Ist_Abwesend(Datum : Datum_Typ) return Boolean;
-- Vorbedingung     : Datum ist ein gueltiges Datum
--
-- Nachbedingung    : Ist der Abwesenheitsgrund 'keine' wird false , sonst
--                    true ausgegeben.
-- Fehlerbehandlung : Exception "Ungueltiges_Datum"
-------------------------------------------------------------------------------


-------------------------------------------------------------------------------
function Abwesenheitsgrund(Datum : Datum_Typ) return Abwesenheits_typ;
-- Vorbedingung     : 1) Datum ist ein gueltiges Datum
--
-- Nachbedingung    : Liefert den Grund der Abwesenheit.
--                    
-- Fehlerbehandlung : 1) Exception "Ungueltiges_Datum"
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
procedure Lese_Daten;
-- Vorbedingung     : keine
--
-- Nachbedingung    : Die Datei "Abwesenheitsmarkierung" wird ,wenn vorhanden,
--                    gelesen.
--
-- Fehlerbehandlung : keine
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
procedure Schreibe_Daten;
-- Vorbedingung     : keine
--
-- Nachbedingung    : Die Datei "Abwesenheitsmarkierung" wird ,wenn 
--                    Markierungenn vorhanden geschrieben.
--
-- Fehlerbehandlung : keine
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
procedure Setze_Markierung (Datum1,Datum2 : Datum_Typ;
			       Grund : Abwesenheits_Typ);
-- Vorbedingung     : 1) Gueltiges Datum
--
-- Nachbedingung    : Die Datei "Abwesenheitsmarkierung" wird ,wenn 
--                    Markierungenn vorhanden geschrieben.
--
-- Fehlerbehandlung : 1) Exception "Ungueltiges_Datum"
-------------------------------------------------------------------------------

end Abwesenheitsmarkierung;

