--*****************************************************************************
-- Datei            : ada_tcl.ads
-- Project          : Terminkalender  ( FaPra WS1995/96 Gruppe 5 )
-- Version          : 
-- Autor            : 
-- Hardware         : DEC-Workstation 3100
-- Betriebssystem   : Ultrix Version 4.3
-- Sprache          : Ada95
-- Compiler         : gnat Version 2.07
-- Erstellungsdatum : 
-------------------------------------------------------------------------------
-- Aufgabe          : Prozeduren fuer Tcl zur verfuegung stellen
-- Anwendung        :
-- Einschraenkung   :
-- Fehlerbehandlung :
--*****************************************************************************

with Adatcl ; use Adatcl;

package Ada_Tcl is

-------------------------------------------------------------------------------
function Ada_Markierung_Setzen (cdata:  in tcl_clientdata;
                 interp: in tcl_interp;
                 argc:   in integer;
                 argv:   in tcl_cstringvec
  ) return tcl_status;
--
--  --> <Anfangsdatum>:<Enddatum>:<Markierung>
--  <--
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
function Ada_Login (cdata:  in tcl_clientdata;
                 interp: in tcl_interp;
                 argc:   in integer;
                 argv:   in tcl_cstringvec
  ) return tcl_status;
--
--  --> Login Name
--  <-- 
--
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
function Ada_Monatsuebersicht (cdata:  in tcl_clientdata;
                 interp: in tcl_interp;
                 argc:   in integer;
                 argv:   in tcl_cstringvec
  ) return tcl_status;
--
-- -> Datum des mittleren anzuzeigenden Monats in der Form
--    "<Monat>.<Jahr>"
-- <- alle Daten zum Aufbau der Monatsuebersicht
--    <Monat_1>:<Jahr_1>:<Monat_2>:<Jahr_2>:<Monat_3>:<Jahr_3>
--    :<KWs_1>:<Montage_1>:<Dienstage_1>:...:<Sonntage_1>:
--    <KWs_2>:...:<KWs_3>:...:<Sonntage_3>"
--
--    <Monat_1> Nummer des Monats links
--    ...
--    <Jahr_1>  Nummer des Jahres links
--    ...
--    <KWs_x> mit ":" voneinander getrennte Liste der KWs im
--    Monat x, aufgefuellt mit " " auf sechs Eintraege
--
--    <Montage_x> <Tagnummer> aller Montage im Monat x,
--    aufgefuellt mit " " auf sechs Eintraege
--
--      <Tagnummer> <Nummer des Tages im Monat>:<Vordergrund>
--      :<Hintergrund>
--      <Hintergrund>
--      0 fuer normal
--      1 fuer Feiertag/Wochenende
--       <Vordergrund>
--      0 fuer normal
--      1 fuer Abwesenheit
--      2 fuer Termin
--
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
function Ada_Wochenuebersicht (cdata:  in tcl_clientdata;
                 interp: in tcl_interp;
                 argc:   in integer;
                 argv:   in tcl_cstringvec
  ) return tcl_status;
--
-- -> Nummer der anzuzeigenden Woche in der Form
--    "<Woche>.<Jahr>
-- <- alle Daten zum Aufbau der Wochenuebersicht
--    <KW1>:<Jahr1>:<KW2>:<Jahr2>:<KW3>:<Jahr3>:<Intervall2>:<Termine2>
--    <KW> Nummer der Woche
--    <Intervall> String der Form "14.8.1995 bis 20.8.1995"
--    <Termine> Liste aus allen Tagen der Woche mit Wochentag
--              und Datum sowie den Terminen des Tages
--              (siehe auch Spezifikation: 3.2.2)
--         z.b: "MONTAG, 14.9.1996 (URLAUB)"
--              "  08:00 - 09:00 kurzbeschr."
--              ....
--
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
function Ada_Tagesuebersicht (cdata:  in tcl_clientdata;
                 interp: in tcl_interp;
                 argc:   in integer;
                 argv:   in tcl_cstringvec
  ) return tcl_status;
--
-- -> Datum des anzuzeigenden Tages in der Form
--    "<Tag>.<Monat>.<Jahr>"
-- <- alle Daten zum Aufbau der Tagesuebersicht
--    <Tag1>:<Tag2>:<Tag3>:<Wochentag>:<Feiertag>:<Abwesenheit>:<Termine>:
--    <Wochentag> Der Wochentag halt (von Tag2)
--    <Feiertag> Name des Feiertags, falls kein Feiertag,
--               leerer Eintrag " "
--    <Abwesenheit> Abwesenheitsmarkierung, falls keine,
--                  leerer Eintrag " "
--    <Termine> Liste aller Termine in der form <Termin>:<Termin>:...
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
function Ada_Termindaten (cdata:  in tcl_clientdata;
                 interp: in tcl_interp;
                 argc:   in integer;
                 argv:   in tcl_cstringvec
  ) return tcl_status;
--
-- -> Datum und Anfangszeit des Termins in der Form
--    "<Tag>.<Monat>.<Jahr>:<Anfangszeit>"
-- <- alle Daten des Termins
--    <Datum>:<Anfangszeit>:<Endzeit>:<Kurzbeschreibung>:
--    <Ort>:<Kommentar1>:<Kommentar2>:<Kommentar3>:
--    <Teilnehmer1>:<Teilnehmer2>:...
--
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
function Ada_Termin_Loeschen (cdata:  in tcl_clientdata;
                 interp: in tcl_interp;
                 argc:   in integer;
                 argv:   in tcl_cstringvec
  ) return tcl_status;
--
-- -> Datum und Anfangszeit des Termins in der Form
--    "<Tag>.<Monat>.<Jahr>:<Anfangszeit>"
-- <- 
--
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
function Ada_Termin_Eintragen (cdata:  in tcl_clientdata;
                 interp: in tcl_interp;
                 argc:   in integer;
                 argv:   in tcl_cstringvec
  ) return tcl_status;
--
-- -> alle Daten des Termins
--    Datum>:<Anfangszeit>:<Endzeit>:<Kurzbeschreibung>:
--    <Ort>:<Kommentar1>:<Kommentar2>:<Kommentar3>:
--    <Teilnehmer1>:<Teilnehmer2>:...
-- <-
--
-------------------------------------------------------------------------------

end Ada_Tcl;





