--*****************************************************************************
-- Datei            : tclmodule.adb
-- Project          : Terminkalender  ( FaPra WS1995/96 Gruppe 5 )
-- Version          : 
-- Autor            : 
-- Hardware         : DEC-Workstation 3100
-- Betriebssystem   : Ultrix Version 4.3
-- Sprache          : Ada95
-- Compiler         : gnat Version 2.07
-- Erstellungsdatum : 
-------------------------------------------------------------------------------
-- Aufgabe          : 
-- Anwendung        :
-- Einschraenkung   :
-- Fehlerbehandlung :
--*****************************************************************************
with system; use system;
with io_exceptions;
with text_io;
with unchecked_deallocation;
with unchecked_conversion;
with sysdep; use sysdep;
with cstrings; use cstrings;
with adatcl; use adatcl;

-------------------------------------------------------------------------------
-- Hier folgen die Ada-Pakete, die Tcl-Funktionen zur verfuegung stellen.
-------------------------------------------------------------------------------
-- z.B. with unsers;
with Ada_Tcl;

package body tclmodule is

TCL_FILE : constant String := 
"/users/students/fapra/fapra5/freigegeben/Version1/daten/terminkalender.tcl";

-------------------------------------------------------------------------------
-- Start wird zu beginn aufgerufen und macht die Ada-Prozeduren Tcl bekannt.
-- Es koennen auch eigene Initialisierungen der Ada-Teile durchgefuehrt werden.
-------------------------------------------------------------------------------
procedure start
is
  interp: tcl_interp;
  status: tcl_status;
  win:    tk_window;
begin
  interp := tcl_createinterp;
  win := tk_createmain (interp, "Nix");
  status := tcl_init (interp);
  if status /= tcl_ok then
    text_io.put_line("Fehler: TCL konnte nicht initialisiert werden!");
    return;
  end if;
  status := tk_init (interp);
  if status /= tcl_ok then
    text_io.put_line("Fehler: Tk konnte nicht initialisiert werden!");
    return;
  end if;

  -- Tcl-Befehle --------------------------------------------------------------
  -- tcl_createcommand (interp, "adacmd", unsers.adacmd'address);
  -----------------------------------------------------------------------------
  Tcl_Createcommand (Interp, "ada_login",
                     Ada_Tcl.Ada_Login'Address);
  Tcl_Createcommand (Interp, "ada_abwesenheit_setzen",
                     Ada_Tcl.Ada_Markierung_Setzen'Address);
  Tcl_Createcommand (Interp, "ada_monatsuebersicht",
                     Ada_Tcl.Ada_Monatsuebersicht'Address);
  Tcl_Createcommand (Interp, "ada_wochenuebersicht",
                     Ada_Tcl.Ada_Wochenuebersicht'Address);
  Tcl_Createcommand (Interp, "ada_tagesuebersicht",
                     Ada_Tcl.Ada_Tagesuebersicht'Address);
  Tcl_Createcommand (Interp, "ada_termindaten",
                     Ada_Tcl.Ada_Termindaten'Address);
  Tcl_Createcommand (Interp, "ada_termin_loeschen",
                     Ada_Tcl.Ada_Termin_Loeschen'Address);
  Tcl_Createcommand (Interp, "ada_termin_eintragen",
                     Ada_Tcl.Ada_Termin_Eintragen'Address);

  status := tcl_evalfile (interp, TCL_FILE);
  if status /= tcl_ok then
    text_io.put_line("Fehler: TCL-Skript konnte nicht ausgefuehrt werden!");
    return;
  end if;
  tk_mainloop;
end;

end;
