#
# Generelle Optionen
#
option add *background grey85
. configure -bg grey85

#
# Konstanten
#
set Tagnamenliste "Mo Di Mi Do Fr Sa So"
set Tagnamenlistelang "Montag Dienstag Mittwoch Donnerstag Freitag Samstag Sonntag"
set Tagnamenlistesystem "Mon Tue Wed Thu Fri Sat Sun"
set Monatsnamenliste "{ } Januar Februar Maerz April Mai Juni Juli August September Oktober November Dezember"
set Monatsnamenlistesystem "{ } Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dez"
set fehlermeldung "Diese Funktion ist derzeit nicht implementiert!"
set VordergrundFarben "black grey99"
set HintergrundFarben "grey85 grey70 grey55"
set fixedfont "-misc-fixed-*-*-*-*-*-140-*-*-*-*-*-*"

set tag 0
set woche 0
set monatnr 0
set monatname 0
set jahr 0
set wochentag 0
set Kalenderbenutzer 0
set datumakt 0
set wocheakt 0
set jahrakt 0

#
# User Login-Name feststellen
#
set user [array get env]
set index [lsearch -exact $user USER]
incr index
set userlogin [lindex $user $index]
#set userlogin [exec {~/.getuserlogin}]
puts "helloworld"
puts $userlogin
ada_login $userlogin


#
# Heutiges Datum feststellen
# Unix-Aufruf "date", Rueckgabeformat "Tue Jan 23 12:51:38 MET 1996"
set datum [exec date]
set tagnamesystem [lindex $datum 0]
set monatsnamesystem [lindex $datum 1]
set tag [lindex $datum 2]
set jahr [lindex $datum 5]
set wochentag [lsearch -exact $Tagnamenlistesystem $tagnamesystem]
set wochentag [lindex $Tagnamenlistelang $wochentag]
set monatnr [lsearch -exact $Monatsnamenlistesystem $monatsnamesystem]
set monatname [lindex $Monatsnamenliste $monatnr]

#
# Dummy-Prozeduren, werden spaeter durch Ada ersetzt
#
proc ada_teilnehmer {} {
set userliste ""
set fileid [open /users/students/fapra/fapra5/freigegeben/Version1/daten/benutzerliste r]
while {[eof $fileid] == "0"} {
    gets $fileid zeile
    if {$zeile != ""} {
	set liste [split $zeile :]
	set realname [lindex $liste 0]
	lappend userliste $realname
    }
}
set userliste [join $userliste @]
return $userliste
}

#
# Ada-Tcl-Kommunikation
#


# Initialisierung der Konstanten
proc init {} {
    global Kalenderbenutzer
    set Kalenderbenutzer [ada_teilnehmer]
}

# Aufbereitung der Daten fuer die Monatsuebersicht
proc daten_monat {monatnr jahr} {
    set datum $monatnr.$jahr
    return [ada_monatsuebersicht $datum]
}

#
# Hilfsfunktionen
#
proc vg {vordergrund} {
    global VordergrundFarben
    return [lindex $VordergrundFarben $vordergrund]
}

proc hg {hintergrund} {
    global HintergrundFarben
    return [lindex $HintergrundFarben $hintergrund]
}

proc existiert_fenster {fenster} {
    set existiert [winfo exists .$fenster]
    return $existiert
}

proc neuer_frame {fenster} {
frame .$fenster.testframe
}

#
# Buttons in Fenstern disablen/enablen
#
proc disable_monatsuebersicht {} {
    for {set fenster 1} {$fenster < 4} {incr fenster 1} {
        for {set kw 1} {$kw < 7} {incr kw 1} {
            .monate.$fenster.u$fenster.k.$kw configure -state disabled
        }
        for {set tagspalte 1} {$tagspalte < 8} {incr tagspalte 1} {
            for {set tag 1} {$tag < 7} {incr tag 1} {
              .monate.$fenster.u$fenster.u.$tagspalte.$tag configure -state disabled
            }
        }
    }
    for {set button 1} {$button < 6} {incr button 1} {
        .buttons.$button configure -state disabled
    }
    for {set button 1} {$button < 5} {incr button 1} {
        .buttons2.$button configure -state disabled
    }
}

proc enable_monatsuebersicht {} {
    for {set fenster 1} {$fenster < 4} {incr fenster 1} {
        for {set kw 1} {$kw < 7} {incr kw 1} {
            set text [.monate.$fenster.u$fenster.k.$kw cget -text]
            if {$text == " "} {
                set status "disabled"
                set variable " "
            } else {
                set status "normal"
            }
            .monate.$fenster.u$fenster.k.$kw configure -state $status
        }
        for {set tagspalte 1} {$tagspalte < 8} {incr tagspalte 1} {
            for {set tag 1} {$tag < 7} {incr tag 1} {
                set text [.monate.$fenster.u$fenster.u.$tagspalte.$tag cget -text]
                if {$text == " "} {
                    set status "disabled"
                    set variable " "
                } else {
                    set status "normal"
                }
                .monate.$fenster.u$fenster.u.$tagspalte.$tag configure -state $status
            }
        }
    }
    for {set button 1} {$button < 6} {incr button 1} {
        .buttons.$button configure -state normal
    }
    for {set button 1} {$button < 5} {incr button 1} {
        .buttons2.$button configure -state normal
    }
}

proc disable_wochenuebersicht {} {
    set existiert [existiert_fenster woche]
    if {$existiert == "1"} {
	.woche.buttons.vw configure -state disabled
	.woche.buttons.mu configure -state disabled
	.woche.buttons.nw configure -state disabled
    }
}


proc enable_wochenuebersicht {} {
    set existiert [existiert_fenster woche]
    if {$existiert == "1"} {
	.woche.buttons.vw configure -state normal
	.woche.buttons.mu configure -state normal
	.woche.buttons.nw configure -state normal
    }
}

proc disable_tagesuebersicht {} {
    set existiert [existiert_fenster tagesuebersicht]
    if {$existiert == "1"} {
	.tagesuebersicht.buttons.vw configure -state disabled
	.tagesuebersicht.buttons.nw configure -state disabled
	.tagesuebersicht.buttons2.wo configure -state disabled
	.tagesuebersicht.buttons2.mu configure -state disabled
    }
}

proc enable_tagesuebersicht {} {
    set existiert [existiert_fenster tagesuebersicht]
    if {$existiert == "1"} {
	.tagesuebersicht.buttons.vw configure -state normal
	.tagesuebersicht.buttons.nw configure -state normal
	.tagesuebersicht.buttons2.wo configure -state normal
	.tagesuebersicht.buttons2.mu configure -state normal
    }
}

proc disable_termineintragen {} {
    set existiert [existiert_fenster te]
    if {$existiert == "1"} {
        .te.button.e configure -state disabled
        .te.button.a configure -state disabled
    }
}

proc enable_termineintragen {} {
    set existiert [existiert_fenster te]
    if {$existiert == "1"} {
        .te.button.e configure -state normal
        .te.button.a configure -state normal
    }
}

proc disable_terminanzeigen {} {
    set existiert [existiert_fenster ta]
    if {$existiert == "1"} {
        .ta.button.e configure -state disabled
        .ta.button.l configure -state disabled
        .ta.button.a configure -state disabled
    }
}

proc enable_terminanzeigen {} {
    set existiert [existiert_fenster ta]
    if {$existiert == "1"} {
        .ta.button.e configure -state normal
        .ta.button.l configure -state normal
        .ta.button.a configure -state normal
    }
}

proc disable_gehezu {} {
    set existiert [existiert_fenster g]
    if {$existiert == "1"} {
        for {set lauf 1} {$lauf < 4} {incr lauf 1} {
            .g.$lauf configure -state disabled
        }
    }
}

proc enable_gehezu {} {
    set existiert [existiert_fenster g]
    if {$existiert == "1"} {
        for {set lauf 1} {$lauf < 4} {incr lauf 1} {
            .g.$lauf configure -state normal
        }
    }
}

proc disable_abwesenheit {} {
    set existiert [existiert_fenster abwesenheit]
    if {$existiert == "1"} {
        for {set lauf 1} {$lauf < 4} {incr lauf 1} {
            .abwesenheit.buttons.1 configure -state disabled
            .abwesenheit.buttons.2 configure -state disabled
        }
    }
}

proc enable_abwesenheit {} {
    set existiert [existiert_fenster abwesenheit]
    if {$existiert == "1"} {
        for {set lauf 1} {$lauf < 4} {incr lauf 1} {
            .abwesenheit.buttons.1 configure -state normal
            .abwesenheit.buttons.2 configure -state normal
        }
    }
}

#----------------------------
#
# Fenster: Sicherheitsabfrage
#
#----------------------------

proc sicherheitsabfrage {text procja procnein} {
    disable_monatsuebersicht
    disable_wochenuebersicht
    disable_tagesuebersicht
    disable_termineintragen
    disable_terminanzeigen
    disable_gehezu
    disable_abwesenheit
    toplevel .sicherheitsabfrage
    wm title .sicherheitsabfrage Sicherheitsabfrage
    wm resizable .sicherheitsabfrage 0 0

    message .sicherheitsabfrage.text -width 3i -bd 20 -justify center -text $text
    pack .sicherheitsabfrage.text -side top -fill both -pady 30

    frame .sicherheitsabfrage.buttons
    pack .sicherheitsabfrage.buttons -side bottom -fill both
    
    button .sicherheitsabfrage.buttons.ja -justify center -text "JA" -command "$procja"
    button .sicherheitsabfrage.buttons.nein -justify center -text "NEIN" -command "$procnein"

    pack .sicherheitsabfrage.buttons.ja .sicherheitsabfrage.buttons.nein -expand yes -padx 20 -pady 10 -side left
}

#-----------------------
#
# Fenster: Fehlermeldung
#
#-----------------------

proc fehlermeldung {fehler} {
    disable_monatsuebersicht
    disable_wochenuebersicht
    disable_tagesuebersicht
    disable_termineintragen
    disable_terminanzeigen
    disable_gehezu
    disable_abwesenheit
    toplevel .fehlermeldung
    wm title .fehlermeldung Fehlermeldung
    wm resizable .fehlermeldung 0 0

    frame .fehlermeldung.fehlertext -relief sunken
    pack .fehlermeldung.fehlertext -side top -fill both
    message .fehlermeldung.fehlertext.top -width 3i -bd 20 -justify center -text $fehler
    pack .fehlermeldung.fehlertext.top -side top -fill both -pady 30
    frame .fehlermeldung.buttons
    pack .fehlermeldung.buttons -side bottom -fill both
    button .fehlermeldung.buttons.ok -justify center -text "OK" -command "ok_fehlermeldung"
    pack .fehlermeldung.buttons.ok -expand yes -padx 20 -pady 10 -side bottom
}

proc ok_fehlermeldung {} {
    enable_monatsuebersicht
    enable_wochenuebersicht
    enable_tagesuebersicht
    enable_termineintragen
    enable_terminanzeigen
    enable_gehezu
    enable_abwesenheit
    destroy .fehlermeldung
}


#--------------------------
#
# Fenster: Termin eintragen
#
#--------------------------

proc termin_eintragen {} {
    global fixedfont Teteilnehmerliste Kalenderbenutzer jahrliste monatliste markiert markz marks markflag markf te1 te2 te3 te4 te5 te6 te7 te8
    set existiert [existiert_fenster te]
    if {$existiert == "1"} {
        destroy .te
    }
    # Markierung, Daten holen: Datum
    if {$markflag == "1" && $markiert == "1"} {
        set tag [.monate.$markf.u$markf.u.$marks.$markz cget -text]
        set monat [lindex $monatliste $markf]
        set jahr [lindex $jahrliste $markf]
        set markiertes_datum $tag.$monat.$jahr
    } {
	set markiertes_datum ""
    }
    set te1 $markiertes_datum
#    set te2 "15:30"
#    set te3 "16:00"
#    set te4 "Kurz"
    # Konstanten
    set unselected "\[ \] "
    set selected "\[X\] "

    # Variablenvorbelegung
    set Kalenderbenutzerliste [split $Kalenderbenutzer @]

    # erzeuge andere Listen
    set Kalenderbenutzerlisteu $Kalenderbenutzerliste
    set Kalenderbenutzerlistes $Kalenderbenutzerliste
    set elemente [llength $Kalenderbenutzerliste]

    for {set lauf 0} {$lauf < $elemente} {incr lauf 1} {
        set ersetzen $unselected[lindex $Kalenderbenutzerliste $lauf]
        set Kalenderbenutzerlisteu [lreplace $Kalenderbenutzerlisteu $lauf $lauf $ersetzen]
        set ersetzen $selected[lindex $Kalenderbenutzerliste $lauf]
        set Kalenderbenutzerlistes [lreplace $Kalenderbenutzerlistes $lauf $lauf $ersetzen]
    }

    set Teteilnehmerliste {}
    set single {0}

    for {set lauf 0} {$lauf < $elemente} {incr lauf 1} {
        set Teteilnehmerliste [concat $Teteilnehmerliste 0]
    }

    # eigenes Fenster mit Titel, nicht vergroesserbar
    toplevel .te
    wm title .te "Termin eintragen"
    wm resizable .te 0 0

    # Teilframes
    frame .te.leer
    frame .te.datum
    frame .te.anfang
    frame .te.ende
    frame .te.kurz
    frame .te.ort
    frame .te.andere
    frame .te.komm
    frame .te.button

    pack .te.leer -side top -pady 10
    pack .te.datum .te.anfang .te.ende .te.kurz .te.ort -side top -fill x -pady 3
    pack .te.andere -side top -expand yes -fill both -padx 5
    pack .te.button .te.komm -side bottom -fill x -pady 5

    # Labels und entrys
    label .te.datum.l -text "Datum: "
    entry .te.datum.e -width 30 -textvariable te1
    pack .te.datum.l -side left -padx 5
    pack .te.datum.e -side right -padx 5

    label .te.anfang.l -text "Anfangszeit: "
    entry .te.anfang.e -width 30 -textvariable te2
    pack .te.anfang.l -side left -padx 5
    pack .te.anfang.e -side right -padx 5

    label .te.ende.l -text "Endzeit: "
    entry .te.ende.e -width 30 -textvariable te3
    pack .te.ende.l -side left -padx 5
    pack .te.ende.e -side right -padx 5

    label .te.kurz.l -text "Kurzbeschreibung: "
    entry .te.kurz.e -width 30 -textvariable te4
    pack .te.kurz.l -side left -padx 5
    pack .te.kurz.e -side right -padx 5

    label .te.ort.l -text "Ort: "
    entry .te.ort.e -width 30 -textvariable te5
    pack .te.ort.l -side left -padx 5
    pack .te.ort.e -side right -padx 5

    label .te.komm.l -text "Kommentar:"
    pack .te.komm.l -side top -padx 5 -anchor w

    entry .te.komm.e1 -width 55 -textvariable te6
    entry .te.komm.e2 -width 55 -textvariable te7
    entry .te.komm.e3 -width 55 -textvariable te8
    pack .te.komm.e1 .te.komm.e2 .te.komm.e3 -side top -padx 5 -pady 2

    button .te.button.e -text "Eintragen" -justify center -command "termin_ein"
    button .te.button.a -text "Abbruch" -justify center -command "termin_abbruch"
    pack .te.button.e -side left -anchor w -padx 5
    pack .te.button.a -side right -anchor e -padx 5

    label .te.andere.l -text "Namen anderer Teilnehmer"
    pack .te.andere.l -side top -anchor w
    listbox .te.andere.liste -yscroll ".te.andere.scroll set" -selectmode single -font $fixedfont -takefocus 0
    scrollbar .te.andere.scroll -command ".te.andere.liste yview" -takefocus 0
    pack .te.andere.liste -side left -fill both -expand yes
    pack .te.andere.scroll -side right -fill y

    for {set lauf 0} {$lauf < $elemente} {incr lauf 1} {
        .te.andere.liste insert end [lindex $Kalenderbenutzerlisteu $lauf]
    }

    bind .te.andere.liste <ButtonRelease-1> "{select_termineintragen} {Teteilnehmerliste} {$Kalenderbenutzerlistes} {$Kalenderbenutzerlisteu}"
}

proc termin_ein {} {
    global Teteilnehmerliste Kalenderbenutzer te1 te2 te3 te4 te5 te6 te7 te8 datumakt wocheakt jahrakt
#    global Kalenderbenutzer datumakt wocheakt jahrakt
    set liste ""
    set teilnehmer ""
    set Kalenderbenutzerliste [split $Kalenderbenutzer @]
    set Anzahl_Teilnehmer [llength $Teteilnehmerliste]
    for {set lauf 0} {$lauf < $Anzahl_Teilnehmer} {incr lauf 1} {
        set wert [lindex $Teteilnehmerliste $lauf]
        if {$wert == "1"} {
            set insert [lindex $Kalenderbenutzerliste $lauf]
            set teilnehmer [linsert $teilnehmer 0 $insert]
        }
    }
    set teilnehmer [join $teilnehmer @]
    set liste "@"
    set liste [linsert $liste 0 $teilnehmer]
    set liste [linsert $liste 0 $te1 $te2 $te3 $te4 $te5 $te6 $te7 $te8]
    set liste [join $liste @]
    set fehler [ada_termin_eintragen $liste]
    set fehler [split $fehler @]
    set fehlerstr [lindex $fehler 0]
    if {$fehlerstr == "0"} {
        termin_abbruch
        update_monatsuebersicht
        set existiert  [existiert_fenster woche]
        if {$existiert == "1"} {
            update_wochenuebersicht $wocheakt $jahrakt
        }
        set existiert [existiert_fenster tagesuebersicht]
        if {$existiert == "1"} {
            update_tagesuebersicht $datumakt
        }
    } else {
        fehlermeldung [lindex $fehler 1]
    }
}

proc termin_abbruch {} {
    global Teteilnehmerliste te1 te2 te3 te4 te5 te6 te7 te8
    destroy .te
    set te1 ""
    set te2 ""
    set te3 ""
    set te4 ""
    set te5 ""
    set te6 ""
    set te7 ""
    set te8 ""
    set Teteilnehmerliste [clear_list $Teteilnehmerliste]
}

proc clear_list {Teilnehmerliste} {
    set Anzahl_Teilnehmer [llength $Teilnehmerliste]
    incr Anzahl_Teilnehmer -1
    set Teilnehmerliste [lreplace $Teilnehmerliste 0 $Anzahl_Teilnehmer 0]
    return $Teilnehmerliste
}

proc select_termineintragen {T Kalenderbenutzerlistes Kalenderbenutzerlisteu} {
    upvar $T Teilnehmerliste
    set elementnummer [.te.andere.liste curselection]
    .te.andere.liste selection clear $elementnummer
    if {[lindex $Teilnehmerliste $elementnummer] == "0"} {
        set element [lindex $Kalenderbenutzerlistes $elementnummer]
        set Teilnehmerliste [lreplace $Teilnehmerliste $elementnummer $elementnummer 1]
    } else {
        set element [lindex $Kalenderbenutzerlisteu $elementnummer]
        set Teilnehmerliste [lreplace $Teilnehmerliste $elementnummer $elementnummer 0]
    }
    .te.andere.liste delete $elementnummer
    .te.andere.liste insert $elementnummer $element
}

#-------------------------
#
# Fenster: Termin anzeigen
#
#-------------------------

proc termin_anzeigen {termin} {
    global fixedfont Tateilnehmerliste Kalenderbenutzer t1 t2 t3 t4 t5 t6 t7 t8 Termin
    set existiert [existiert_fenster ta]
    if {$existiert == "1"} {
        destroy .ta
    }
    # Konstanten
    set unselected "\[ \] "
    set selected "\[X\] "

    # Variablenvorbelegung
    set Termindaten [ada_termindaten $termin]
    set Termindaten [split $Termindaten @]
    set Termin $Termindaten
    set t1 [lindex $Termindaten 2]
    set t2 [lindex $Termindaten 3]
    set t3 [lindex $Termindaten 4]
    set t4 [lindex $Termindaten 5]
    set t5 [lindex $Termindaten 6]
    set t6 [lindex $Termindaten 7]
    set t7 [lindex $Termindaten 8]
    set t8 [lindex $Termindaten 9]
    set Termindaten [lreplace $Termindaten 0 9]
#    set Teilnehmer "0@0@1@1@0@0"
    set Kalenderbenutzerliste [split $Kalenderbenutzer @]
    set Tateilnehmerliste {}
    set single {0}
    set elemente [llength $Kalenderbenutzerliste]
    for {set lauf 0} {$lauf < $elemente} {incr lauf 1} {
        set Tateilnehmerliste [concat $Tateilnehmerliste 0]
    }

    set Tateilnehmerliste [erzeuge_teilnehmer $Termindaten $Kalenderbenutzerliste $Tateilnehmerliste]

    # erzeuge andere Listen
    set Kalenderbenutzerlisteu $Kalenderbenutzerliste
    set Kalenderbenutzerlistes $Kalenderbenutzerliste
    set elemente [llength $Kalenderbenutzerliste]
    for {set lauf 0} {$lauf < $elemente} {incr lauf 1} {
        set ersetzen $unselected[lindex $Kalenderbenutzerliste $lauf]
        set Kalenderbenutzerlisteu [lreplace $Kalenderbenutzerlisteu $lauf $lauf $ersetzen]
        set ersetzen $selected[lindex $Kalenderbenutzerliste $lauf]
        set Kalenderbenutzerlistes [lreplace $Kalenderbenutzerlistes $lauf $lauf $ersetzen]
    }

    set Kalenderbenutzerlistea $Kalenderbenutzerlisteu
    for {set lauf 0} {$lauf < $elemente} {incr lauf 1} {
        if {[lindex $Tateilnehmerliste $lauf] == "0"} {
            set element [lindex $Kalenderbenutzerlisteu $lauf]
        } else {
            set element [lindex $Kalenderbenutzerlistes $lauf]
        }
        set Kalenderbenutzerlistea [lreplace $Kalenderbenutzerlistea $lauf $lauf $element]
    }


    # eigenes Fenster, nicht vergroesserbar
    toplevel .ta
    wm title .ta "Termin anzeigen"
    wm resizable .ta 0 0

    # Teilframes
    frame .ta.leer
    frame .ta.datum
    frame .ta.anfang
    frame .ta.ende
    frame .ta.kurz
    frame .ta.ort
    frame .ta.andere
    frame .ta.komm
    frame .ta.button

    pack .ta.leer -side top -pady 10
    pack .ta.datum .ta.anfang .ta.ende .ta.kurz .ta.ort -side top -fill x -pady 3
    pack .ta.andere -side top -expand yes -fill both -padx 5
    pack .ta.button .ta.komm -side bottom -fill x -pady 5

    # Labels und entrys
    label .ta.datum.l -text "Datum: "
    entry .ta.datum.e -width 30 -textvariable t1

    label .ta.anfang.l -text "Anfangszeit: "
    entry .ta.anfang.e -width 30 -textvariable t2

    label .ta.ende.l -text "Endzeit: "
    entry .ta.ende.e -width 30 -textvariable t3

    label .ta.kurz.l -text "Kurzbeschreibung: "
    entry .ta.kurz.e -width 30 -textvariable t4

    label .ta.ort.l -text "Ort: "
    entry .ta.ort.e -width 30 -textvariable t5
    pack .ta.datum.l .ta.anfang.l .ta.ende.l .ta.kurz.l .ta.ort.l -side left -padx 5
    pack .ta.datum.e .ta.anfang.e .ta.ende.e .ta.kurz.e .ta.ort.e -side right -padx 5

    label .ta.komm.l -text "Kommentar:"
    pack .ta.komm.l -side top -padx 5 -anchor w

    entry .ta.komm.e1 -width 55 -textvariable t6
    entry .ta.komm.e2 -width 55 -textvariable t7
    entry .ta.komm.e3 -width 55 -textvariable t8
    pack .ta.komm.e1 .ta.komm.e2 .ta.komm.e3 -side top -padx 5 -pady 2

    button .ta.button.e -text "Aendern" -justify center -command "termin_aendern"
    button .ta.button.l -text "Loeschen" -justify center -command "termin_loeschen"
    button .ta.button.a -text "Abbruch" -justify center -command "termin_anzeigen_abbruch"
    pack .ta.button.e -side left -expand yes -anchor w -padx 5
    pack .ta.button.l -side left -expand yes -padx 5
    pack .ta.button.a -side right -anchor e -expand yes -padx 5

    label .ta.andere.l -text "Namen anderer Teilnehmer"
    pack .ta.andere.l -side top -anchor w
    listbox .ta.andere.liste -yscroll ".ta.andere.scroll set" -selectmode single -font $fixedfont
    scrollbar .ta.andere.scroll -command ".ta.andere.liste yview"
    pack .ta.andere.liste -side left -fill both -expand yes
    pack .ta.andere.scroll -side right -fill y

    for {set lauf 0} {$lauf < $elemente} {incr lauf 1} {
        .ta.andere.liste insert end [lindex $Kalenderbenutzerlistea $lauf]
    }

    bind .ta.andere.liste <ButtonRelease-1> "{select_terminanzeigen} {Tateilnehmerliste} {$Kalenderbenutzerlistes} {$Kalenderbenutzerlisteu}"
}

proc termin_aendern {} {
    sicherheitsabfrage "Soll der Termin wirklich geaendert werden?" ja_aendern nein_aendern
}

proc termin_loeschen {} {
    sicherheitsabfrage "Soll der Termin wirklich geloescht werden?" ja_loeschen nein_loeschen
}

proc ja_aendern {} {
    global Termin t1 t2 t3 t4 t5 t6 t7 t8 Tateilnehmerliste
# Termin loeschen
    set uebergabe1 [lindex $Termin 2]
    set uebergabe2 [lindex $Termin 3]
    append uebergabe1 "@" $uebergabe2
    set rueckgabe [ada_termin_loeschen $uebergabe1]
# Termin eintragen, falls Fehler -> Fehlermeldung, alten Termin eintragen
    ta_termin_ein $Termin
    enable_monatsuebersicht
    enable_wochenuebersicht
    enable_tagesuebersicht
    enable_termineintragen
    enable_terminanzeigen
    enable_gehezu
    destroy .sicherheitsabfrage
#    destroy .ta
}

proc nein_aendern {} {
    enable_monatsuebersicht
    enable_wochenuebersicht
    enable_tagesuebersicht
    enable_termineintragen
    enable_terminanzeigen
    enable_gehezu
    destroy .sicherheitsabfrage
}

proc ja_loeschen {} {
    global Termin datumakt wocheakt jahrakt
    set uebergabe1 [lindex $Termin 2]
    set uebergabe2 [lindex $Termin 3]
    append uebergabe1 "@" $uebergabe2
    set rueckgabe [ada_termin_loeschen $uebergabe1]
    if {$wocheakt != "0"} {
	update_wochenuebersicht $wocheakt $jahrakt
    }
    if {$datumakt != "0"} {
	update_tagesuebersicht $datumakt
    }
    update_monatsuebersicht
    enable_monatsuebersicht
    enable_wochenuebersicht
    enable_tagesuebersicht
    enable_termineintragen
    enable_terminanzeigen
    enable_gehezu
    destroy .sicherheitsabfrage
    destroy .ta
}

proc nein_loeschen {} {
    enable_monatsuebersicht
    enable_wochenuebersicht
    enable_tagesuebersicht
    enable_termineintragen
    enable_terminanzeigen
    enable_gehezu
    destroy .sicherheitsabfrage
}

proc termin_anzeigen_abbruch {} {
    destroy .ta
}

proc ta_termin_ein {alter_termin} {
    global Tateilnehmerliste Kalenderbenutzer t1 t2 t3 t4 t5 t6 t7 t8 datumakt wocheakt jahrakt
#    global Kalenderbenutzer datumakt wocheakt jahrakt
    set liste ""
    set teilnehmer ""
    set Kalenderbenutzerliste [split $Kalenderbenutzer @]
    set Anzahl_Teilnehmer [llength $Tateilnehmerliste]
    for {set lauf 0} {$lauf < $Anzahl_Teilnehmer} {incr lauf 1} {
        set wert [lindex $Tateilnehmerliste $lauf]
        if {$wert == "1"} {
            set insert [lindex $Kalenderbenutzerliste $lauf]
            set teilnehmer [linsert $teilnehmer 0 $insert]
        }
    }
    set teilnehmer [join $teilnehmer @]
    set liste "@"
    set liste [linsert $liste 0 $teilnehmer]
    set liste [linsert $liste 0 $t1 $t2 $t3 $t4 $t5 $t6 $t7 $t8]
    set liste [join $liste @]
    set fehler [ada_termin_eintragen $liste]
    set fehler [split $fehler @]
    set fehlerstr [lindex $fehler 0]
    if {$fehlerstr == "0"} {
        termin_anzeigen_abbruch
        update_monatsuebersicht
        set existiert  [existiert_fenster woche]
        if {$existiert == "1"} {
            update_wochenuebersicht $wocheakt $jahrakt
        }
        set existiert [existiert_fenster tagesuebersicht]
        if {$existiert == "1"} {
            update_tagesuebersicht $datumakt
        }
    } else {
	set alter_termin [lreplace $alter_termin 0 1]
	set alter_termin [join $alter_termin @]
	ada_termin_eintragen $alter_termin
        fehlermeldung [lindex $fehler 1]
    }
}

proc select_terminanzeigen {T Kalenderbenutzerlistes Kalenderbenutzerlisteu} {
    upvar $T Teilnehmerliste
    set elementnummer [.ta.andere.liste curselection]
    .ta.andere.liste selection clear $elementnummer

    if {[lindex $Teilnehmerliste $elementnummer] == "0"} {
        set element [lindex $Kalenderbenutzerlistes $elementnummer]
        set Teilnehmerliste [lreplace $Teilnehmerliste $elementnummer $elementnummer 1]
    } else {
        set element [lindex $Kalenderbenutzerlisteu $elementnummer]
        set Teilnehmerliste [lreplace $Teilnehmerliste $elementnummer $elementnummer 0]
    }

    .ta.andere.liste delete $elementnummer
    .ta.andere.liste insert $elementnummer $element
}

proc erzeuge_teilnehmer {Teilnehmer Kalenderbenutzerliste Bitliste} {
set Teilnehmeranzahl [llength $Teilnehmer]
set Kalenderbenutzeranzahl [llength $Kalenderbenutzerliste]
for {set lauf 0} {$lauf < $Teilnehmeranzahl} {incr lauf 1} {
    for {set lauf2 0} {$lauf2 < $Kalenderbenutzeranzahl} {incr lauf2 1} {
        set name1 [lindex $Teilnehmer $lauf]
        set name2 [lindex $Kalenderbenutzerliste $lauf2]
        if {$name1 == $name2} {
            set Bitliste [lreplace $Bitliste $lauf2 $lauf2 "1"]
        }
    }
}
return $Bitliste
}

#---------------------------------------
#
# Fenster: Periodischen Termin eintragen
# nicht implementiert in Minimalsystem
#---------------------------------------

proc periodischen_termin_eintragen {} {
    global fehlermeldung
    fehlermeldung $fehlermeldung
}

#---------------------------------------
#
# Fenster: Termin suchen
# nicht implementiert in Minimalsystem
#---------------------------------------

proc termin_suchen {} {
    global fehlermeldung
    fehlermeldung $fehlermeldung
}

#---------------------------------------
#
# Fenster: Gehe zu
#
#---------------------------------------

proc gehe_zu {} {
    global monatnr jahr
    set existiert [existiert_fenster g]
    if {$existiert == "1"} {
        destroy .g
    }
    toplevel .g
    wm title .g "Gehe zu"
    wm resizable .g 0 0
    label .g.l1 -text "Monat: "
    entry .g.1 -width 5 -textvariable monatnr
    label .g.l2 -text "Jahr: "
    entry .g.2 -width 5 -textvariable jahr
    button .g.3 -text "OK" -justify center -command "test;update_monatsuebersicht"
    bind .g.3 <Return> "test;update_monatsuebersicht"
    bind .g.1 <Return> "test;update_monatsuebersicht"
    bind .g.2 <Return> "test;update_monatsuebersicht"
    pack .g.l1 .g.1 .g.l2 .g.2 -side left
    pack .g.3 -side top
}

proc test {} {
    global monatnr jahr
    if {$monatnr > 12} {
        set monatnr 12
    }
    
    if {$monatnr < 1} {
        set monatnr 1
    }
    
    if {$jahr > 2100} {
        set jahr 2100
    }
    
    if {$jahr < 1990} {
        set jahr 1990
    }
}


#---------------------------------------
#
# Fenster: Periodische Termine
# nicht implementiert in Minimalsystem
#---------------------------------------

proc periodische_termine {} {
    global fehlermeldung
    fehlermeldung $fehlermeldung
}

#---------------------------------------
#
# Fenster: Abwesenheitsmarkierung setzen
# nicht implementiert in Minimalsystem
#---------------------------------------

proc ist_markiert {} {
    global markiert markflag markf markz marks monatliste jahrliste
    if {$markiert == "1"} {
	if {$markflag == "1"} {
	    set tag [.monate.$markf.u$markf.u.$marks.$markz cget -text]
	    set monat [lindex $monatliste $markf]
	    set jahr [lindex $jahrliste $markf]
	    set markiertes_datum1 $tag.$monat.$jahr
	    set markiertes_datum2 $markiertes_datum1
	} {
	    set erster_tag 1
	    set tag1 " "
	    while {$tag1 == " "} {
		set tag1 [.monate.$markf.u$markf.u.$erster_tag.$markz cget -text]
		incr erster_tag 1
	    }
	    set letzter_tag 7
	    set tag2 " "
	    while {$tag2 == " "} {
		set tag2 [.monate.$markf.u$markf.u.$letzter_tag.$markz cget -text]
		incr letzter_tag -1
	    }
	    set monat [lindex $monatliste $markf]
	    set jahr [lindex $jahrliste $markf]
	    set markiertes_datum1 $tag1.$monat.$jahr
	    set markiertes_datum2 $tag2.$monat.$jahr
	}
    } {
	set markiertes_datum1 ""
	set markiertes_datum2 ""
    }
    set liste ""
    lappend liste $markiertes_datum1 $markiertes_datum2
    return $liste
}

proc abwesenheitsmarkierung_setzen {} {
    global ab1 ab2 ab 
    set existiert [existiert_fenster abwesenheit]
    if {$existiert == "1"} {
        destroy .abwesenheit
    }
    set ab ""
    set liste [ist_markiert]
    set ab1 [lindex $liste 0]
    set ab2 [lindex $liste 1]
    toplevel .abwesenheit
    wm title .abwesenheit "Abwesenheitsmarkierung setzen"
    wm resizable .abwesenheit 0 0

    frame .abwesenheit.von
    frame .abwesenheit.bis
    frame .abwesenheit.grund -relief sunken -bd 2
    frame .abwesenheit.label
    frame .abwesenheit.buttons

    pack .abwesenheit.von .abwesenheit.bis .abwesenheit.label -side top -expand yes -fill x -padx 5 -pady 5
    pack .abwesenheit.buttons -side bottom -expand yes -fill x -pady 10
    pack .abwesenheit.grund -side top -expand yes -fill both -padx 5

    label .abwesenheit.von.l -text "von: "
    entry .abwesenheit.von.e -width 30 -textvariable ab1

    label .abwesenheit.bis.l -text "bis: "
    entry .abwesenheit.bis.e -width 30 -textvariable ab2

    pack .abwesenheit.von.l .abwesenheit.bis.l -side left -padx 5
    pack .abwesenheit.von.e .abwesenheit.bis.e -side right -padx 5

    label .abwesenheit.label.l -text "Grund:"
    pack .abwesenheit.label.l -side left -padx 5

    radiobutton .abwesenheit.grund.1 -variable ab -value "1" -text "Urlaub"
    .abwesenheit.grund.1 select
    radiobutton .abwesenheit.grund.2 -variable ab -value "2" -text "Tagung"
    radiobutton .abwesenheit.grund.3 -variable ab -value "3" -text "Dienstreise"

    pack .abwesenheit.grund.1 .abwesenheit.grund.2 .abwesenheit.grund.3 -side top -anchor w

    button .abwesenheit.buttons.1 -text "Setzen" -justify center -command "abwesenheit_setzen"
    button .abwesenheit.buttons.2 -text "Abbruch" -justify center -command "destroy .abwesenheit"

    pack .abwesenheit.buttons.1 -side left -anchor w -padx 5
    pack .abwesenheit.buttons.2 -side right -anchor e -padx 5

}

proc abwesenheit_setzen {} {
    global ab1 ab2 ab monatnr jahr datumakt wocheakt jahrakt
    set an_ada ""
    append an_ada $ab1 "@" $ab2 "@" $ab
    set fehler [ada_abwesenheit_setzen $an_ada]
    set fehler [split $fehler @]
    set fehlerstr [lindex $fehler 0]
    if {$fehlerstr == "0"} {
	destroy .abwesenheit
	update_monatsuebersicht
	set existiert  [existiert_fenster woche]
	if {$existiert == "1"} {
	    update_wochenuebersicht $wocheakt $jahrakt
	}
	set existiert [existiert_fenster tagesuebersicht]
	if {$existiert == "1"} {
	    update_tagesuebersicht $datumakt
	}
    } else {
        fehlermeldung [lindex $fehler 1]
    }
}

proc abwesenheit_loeschen {} {
    global monatnr jahr datumakt wocheakt jahrakt
    set liste [ist_markiert]
    set an_ada ""
    append an_ada [lindex $liste 0] "@" [lindex $liste 1] "@" 0
    ada_abwesenheit_setzen $an_ada
    update_monatsuebersicht
    if {$wocheakt != "0"} {
	update_wochenuebersicht $wocheakt $jahrakt
    }
    if {$datumakt != "0"} {
	update_tagesuebersicht $datumakt
    }
}

#-----------------------------------------
#
# Funktion: Abwesenheitsmarkierung loeschen
# nicht implementiert in Minimalsystem
#-----------------------------------------

proc abwesenheitsmarkierung_loeschen {} {
    abwesenheit_loeschen
}

#--------------------------
#
# Fenster: Tagesuebersicht
#
#--------------------------

proc tagesuebersicht {datum} {
    global datumakt tageslist
    set datumakt $datum
    set existiert [existiert_fenster tagesuebersicht]
    if {$existiert == "1"} {
        update_tagesuebersicht $datum
    } else {
        set var 0
        set ta [ada_tagesuebersicht $datum]
        set lauf 0
        set tageslist [split $ta @]
        set tageslist [lreplace $tageslist 0 1]
        set datum1 [lindex $tageslist 0]
        set datum2 [lindex $tageslist 1]
        set datum3 [lindex $tageslist 2]
        set wochentag [lindex $tageslist 3]
        set feiertag [lindex $tageslist 4]
        set abwesenheit [lindex $tageslist 5]
        set tageslist [lreplace $tageslist 0 5]
	append wochentag ", " $datum2

        toplevel .tagesuebersicht
        wm title .tagesuebersicht Tagesuebersicht
        wm resizable .tagesuebersicht 0 0
        wm geometry .tagesuebersicht 388x492

        frame .tagesuebersicht.datum
        pack .tagesuebersicht.datum -side top -fill x  -padx 5
        label .tagesuebersicht.datum.tagesuebersicht -text $wochentag -justify center
        pack .tagesuebersicht.datum.tagesuebersicht -side top -fill x
        label .tagesuebersicht.datum.feiertag -text $feiertag -justify center
        pack .tagesuebersicht.datum.feiertag -side top -fill x
        label .tagesuebersicht.datum.abwesenheit -text $abwesenheit -justify center
        pack .tagesuebersicht.datum.abwesenheit -side top -fill x

        frame .tagesuebersicht.uebersicht
        pack .tagesuebersicht.uebersicht -side top -fill both -expand yes -pady 10 -padx 5

        listbox .tagesuebersicht.uebersicht.list -yscroll ".tagesuebersicht.uebersicht.scroll set"
        pack .tagesuebersicht.uebersicht.list -side left -fill both -expand yes
        scrollbar .tagesuebersicht.uebersicht.scroll -command ".tagesuebersicht.uebersicht.list yview"
        pack .tagesuebersicht.uebersicht.scroll -side right -fill y
        bind .tagesuebersicht.uebersicht.list <ButtonRelease-1> "{select_tagesuebersicht} {$tageslist}"
        
        set eintraege [llength $tageslist]
        for {set lauf 0} {$lauf < $eintraege} {incr lauf 1} {
            .tagesuebersicht.uebersicht.list insert end [lindex $tageslist $lauf]
        }

        # Buttons
        frame .tagesuebersicht.buttons
        pack .tagesuebersicht.buttons -side top -fill both -padx 5
        button .tagesuebersicht.buttons.vw -text "Vorheriger Tag" -justify center -command "{tagesuebersicht} $datum1"
        pack .tagesuebersicht.buttons.vw -side left -anchor w -expand yes
        button .tagesuebersicht.buttons.nw -text "Naechster Tag" -justify center -command "{tagesuebersicht} $datum3"
        pack .tagesuebersicht.buttons.nw -side right -anchor e -expand yes

        frame .tagesuebersicht.buttons2
        pack .tagesuebersicht.buttons2 -side top -fill both -padx 5
        button .tagesuebersicht.buttons2.wo -text "Wochenuebersicht" -justify center
        pack .tagesuebersicht.buttons2.wo -side left -anchor w -expand yes
        button .tagesuebersicht.buttons2.mu -text "Monatsuebersicht" -justify center -command "monatsuebersicht_updaten"
        pack .tagesuebersicht.buttons2.mu -side right -anchor e -expand yes
    }
}

proc monatsuebersicht_updaten {} {
    global datumakt monatnr jahr
    set a [split $datumakt "."]
    set monatnr [lindex $a 1]
    set jahr [lindex $a 2]
    update_monatsuebersicht
}

proc select_tagesuebersicht {terminliste} {
    global datumakt
    set termin [.tagesuebersicht.uebersicht.list curselection]
    .tagesuebersicht.uebersicht.list selection clear $termin
    set termin [.tagesuebersicht.uebersicht.list get $termin]
    if {$termin != ""} {
	set termin [split $termin " "]
	set termin [lindex $termin 2]
	set an_ada $datumakt
	append an_ada "@" $termin
	termin_anzeigen $an_ada
    }
}

proc update_tagesuebersicht {datum} {
    global datumakt tageslist
    set datumakt $datum
    set var 0
    set ta [ada_tagesuebersicht $datum]
    set lauf 0
    set tageslist [split $ta @]
    set tageslist [lreplace $tageslist 0 1]
    set datum1 [lindex $tageslist 0]
    set datum2 [lindex $tageslist 1]
    set datum3 [lindex $tageslist 2]
    set wochentag [lindex $tageslist 3]
    set feiertag [lindex $tageslist 4]
    set abwesenheit [lindex $tageslist 5]
    set tageslist [lreplace $tageslist 0 5]
    append wochentag ", " $datum2
    .tagesuebersicht.datum.tagesuebersicht configure -text $wochentag
    .tagesuebersicht.datum.feiertag configure -text $feiertag
    .tagesuebersicht.datum.abwesenheit configure -text $abwesenheit
    set size [.tagesuebersicht.uebersicht.list size]
    .tagesuebersicht.uebersicht.list delete 0 [expr $size - 1]
    set eintraege [llength $tageslist]
    for {set lauf 0} {$lauf < $eintraege} {incr lauf 1} {
        .tagesuebersicht.uebersicht.list insert end [lindex $tageslist $lauf]
    }
    .tagesuebersicht.buttons.vw configure -command "{tagesuebersicht} $datum1"
    .tagesuebersicht.buttons.nw configure -command "{tagesuebersicht} $datum3"
}

#--------------------------
#
# Fenster: Wochenuebersicht
#
#--------------------------

proc wochenuebersicht {woche jahr} {
    global wocheakt jahrakt wochenliste wochennummerliste
    set existiert [existiert_fenster woche]
    if {$existiert == "1"} {
        update_wochenuebersicht $woche $jahr
    } else {
        set lauf 0
        set wo2 [ada_wochenuebersicht $woche.$jahr]
        set wochenlist2 [split $wo2 @]
	set wochenlist2 [lreplace $wochenlist2 0 1]
	set woche1 [lindex $wochenlist2 0]
	set woch1 $woche1
	set jahr1 [lindex $wochenlist2 1]
	set woche3 [lindex $wochenlist2 4]
	set woch3 $woche3
	set jahr3 [lindex $wochenlist2 5]
	set wochennummerliste "{} $woche1 $woche $woche3"
	set wochenlist2 [lreplace $wochenlist2 0 5]
        set wo1 [ada_wochenuebersicht $woche1.$jahr1]
        set wo3 [ada_wochenuebersicht $woche3.$jahr3]
        set wocheakt $woche
        set jahrakt $jahr
        set wochenlist1 [split $wo1 @]
	if {$woche1 == $woche} {
	    set wochenlist1 "{} {} {} {} {} {} {} {} {} {}"
	    set woch1 ""
	}
	set wochenlist1 [lreplace $wochenlist1 0 7]
        set wochenlist3 [split $wo3 @]
	if {$woche3 == $woche} {
	    set wochenlist3 "{} {} {} {} {} {} {} {} {} {}"
	    set woch3 ""
	}
	set wochenlist3 [lreplace $wochenlist3 0 7]
        set wochenliste [list dummy $wochenlist1 $wochenlist2 $wochenlist3]
	set wo1text ""
	set wo2text ""
	set wo3text ""
	append wo1text "KW " $woch1
	if {$woch1 == ""} {
	    set wo1text ""
	}
	append wo2text "KW " $woche
	append wo3text "KW " $woch3
	if {$woch3 == ""} {
	    set wo3text ""
	}
	set wotextlist [list $wo1text $wo1text $wo2text $wo3text]

        # eigenes Fenster
        toplevel .woche
        wm title .woche Wochenuebersicht
        wm resizable .woche 0 0
        wm geometry .woche 1138x560

        frame .woche.wochen
        pack .woche.wochen -side top -fill both -padx 5 -expand yes

        for {set wonr 1} {$wonr < 4} {incr wonr 1} {
            set lauf 0
            set wochenlist [lindex $wochenliste $wonr]
            frame .woche.wochen.$wonr
            pack .woche.wochen.$wonr -side left -fill both -expand yes
            frame .woche.wochen.$wonr.ob
            pack .woche.wochen.$wonr.ob -side top -fill x -pady 3
            frame .woche.wochen.$wonr.un
            pack .woche.wochen.$wonr.un -side top -fill both -expand yes
	    set text [lindex $wotextlist $wonr]
            label .woche.wochen.$wonr.ob.kw -text $text
            label .woche.wochen.$wonr.ob.bereich -text [lindex $wochenlist $lauf]
            set wochenlist [lreplace $wochenlist 0 0]
            pack .woche.wochen.$wonr.ob.kw -side left -padx 10
            pack .woche.wochen.$wonr.ob.bereich -side right -padx 10
            listbox .woche.wochen.$wonr.un.list -yscroll ".woche.wochen.$wonr.un.scroll set" -selectmode single
	    bind .woche.wochen.$wonr.un.list <ButtonRelease-1> "select_wochenuebersicht $wonr"
            pack .woche.wochen.$wonr.un.list -side left -fill both -expand yes
            scrollbar .woche.wochen.$wonr.un.scroll -command ".woche.wochen.$wonr.un.list yview"
            pack .woche.wochen.$wonr.un.scroll -side right -fill y
            set eintraege [llength $wochenlist]
            for {set lauf 0} {$lauf < $eintraege} {incr lauf} {
		set eintrag [lindex $wochenlist $lauf]
		if {[string index $eintrag 1] != " "} {
		    .woche.wochen.$wonr.un.list insert end ""
		    .woche.wochen.$wonr.un.list insert end $eintrag
		    .woche.wochen.$wonr.un.list insert end ""
		} {
		    .woche.wochen.$wonr.un.list insert end $eintrag
		}
            }
        }
        # Buttons
        frame .woche.buttons
        pack .woche.buttons -side bottom -fill x -anchor s -padx 5 -pady 5
        button .woche.buttons.vw -text "Vorherige Woche" -justify center -command "{wochenuebersicht} $woche1 $jahr1"
        pack .woche.buttons.vw -side left -anchor w -expand yes
        button .woche.buttons.mu -text "Monatsuebersicht" -justify center -command "{woche_monat}"
        pack .woche.buttons.mu -side left -expand yes
        button .woche.buttons.nw -text "Naechste Woche" -justify center -command "{wochenuebersicht} $woche3 $jahr3"
        pack .woche.buttons.nw -side right -anchor e -expand yes
    }
}

proc select_wochenuebersicht {wonr} {
    set anfangszeit ""
    set selectednr [.woche.wochen.$wonr.un.list curselection]
    .woche.wochen.$wonr.un.list selection clear $selectednr
    set selected [.woche.wochen.$wonr.un.list get $selectednr]
    if {$selected != ""} {
	set selected [split $selected " "]
	set firstelement [lindex $selected 0]
	if {$firstelement == ""} {
	    set anfangszeit [lindex $selected 2]
	    while {$firstelement == ""} {
		incr selectednr -1
		set selected [.woche.wochen.$wonr.un.list get $selectednr]
		set selected [split $selected " "]
		set firstelement [lindex $selected 0]
	    }
	} {
	    set index 0
	}
	set datum [.woche.wochen.$wonr.un.list get $selectednr]
	set datum [split $datum " "]
	set datum [lindex $datum 1]
	if {$anfangszeit == ""} {
	    tagesuebersicht $datum
	} {
	    set an_ada $datum
	    append an_ada "@" $anfangszeit
	    termin_anzeigen $an_ada
	}
    }
}

proc woche_monat {} {
    global monatnr jahr
    set bereich [.woche.wochen.2.ob.bereich cget -text]
    set datum [split $bereich " "]
    set datum [lindex $datum 0]
    set datumliste [split $datum .]
    set monatnr [lindex $datumliste 1]
    set jahr [lindex $datumliste 2]
    update_monatsuebersicht
}

proc update_wochenuebersicht {woche jahr} {
    global wocheakt jahrakt wochenliste wochennummerliste
    set lauf 0
    set wo2 [ada_wochenuebersicht $woche.$jahr]
    set wochenlist2 [split $wo2 @]
    set wochenlist2 [lreplace $wochenlist2 0 1]
    set woche1 [lindex $wochenlist2 0]
    set woch1 $woche1
    set jahr1 [lindex $wochenlist2 1]
    set woche3 [lindex $wochenlist2 4]
    set woch3 $woche3
    set jahr3 [lindex $wochenlist2 5]
    set wochennummerliste "{} $woche1 $woche $woche3"
    set wochenlist2 [lreplace $wochenlist2 0 5]
    set wo1 [ada_wochenuebersicht $woche1.$jahr1]
    set wo3 [ada_wochenuebersicht $woche3.$jahr3]
    set wocheakt $woche
    set jahrakt $jahr
    set wochenlist1 [split $wo1 @]
    if {$woche1 == $woche} {
	set wochenlist1 "{} {} {} {} {} {} {} {} {} {}"
	set woch1 ""
    }
    set wochenlist1 [lreplace $wochenlist1 0 7]
    set wochenlist3 [split $wo3 @]
    if {$woche3 == $woche} {
	set wochenlist3 "{} {} {} {} {} {} {} {} {} {}"
	set woch3 ""
    }
    set wochenlist3 [lreplace $wochenlist3 0 7]
    set wochenliste [list dummy $wochenlist1 $wochenlist2 $wochenlist3]

    set wo1text ""
    set wo2text ""
    set wo3text ""
    append wo1text "KW " $woch1
    if {$woch1 == ""} {
	set wo1text ""
    }
    append wo2text "KW " $woche
    append wo3text "KW " $woch3
    if {$woch3 == ""} {
	set wo3text ""
    }
    set wotextlist [list $wo1text $wo1text $wo2text $wo3text]

    for {set wonr 1} {$wonr < 4} {incr wonr 1} {
	set lauf 0
        set wochenlist [lindex $wochenliste $wonr]
	set text [lindex $wotextlist $wonr]
        .woche.wochen.$wonr.ob.kw configure -text $text
        .woche.wochen.$wonr.ob.bereich configure -text [lindex $wochenlist $lauf]
        set wochenlist [lreplace $wochenlist 0 0]
        set size [.woche.wochen.$wonr.un.list size]
        .woche.wochen.$wonr.un.list delete 0 [expr $size - 1]
        set eintraege [llength $wochenlist]
        for {set lauf 0} {$lauf < $eintraege} {incr lauf} {
	    set eintrag [lindex $wochenlist $lauf]
	    if {[string index $eintrag 1] != " "} {
		.woche.wochen.$wonr.un.list insert end ""
		.woche.wochen.$wonr.un.list insert end $eintrag
		.woche.wochen.$wonr.un.list insert end ""
	    } {
		.woche.wochen.$wonr.un.list insert end $eintrag
	    }
        }
    }
    .woche.buttons.vw configure -command "{wochenuebersicht} $woche1 $jahr1"
    .woche.buttons.nw configure -command "{wochenuebersicht} $woche3 $jahr3"
}

#--------------------------
#
# Fenster: Monatsuebersicht
#
#--------------------------

proc vorheriger_monat {} {
    global monatnr1 jahr1 monatnr jahr
    set monatnr $monatnr1
    set jahr $jahr1
    loesche_markierung
    update_monatsuebersicht
}

proc naechster_monat {} {
    global monatnr3 jahr3 monatnr jahr
    set monatnr $monatnr3
    set jahr $jahr3
    loesche_markierung
    update_monatsuebersicht
}

proc update_monatsuebersicht {} {
    global Monatsnamenliste Tagnamenliste jahr monatnr VordergrundFarben HintergrundFarben monatnr1 monatnr2 monatnr3 jahr1 jahr2 jahr3 jahrliste monatliste
    set daten [daten_monat $monatnr $jahr]
    set list [split $daten @]
    set list [lreplace $list 0 1]
    set monatnr1 [lindex $list 0]
    set jahr1 [lindex $list 1]
    set monatnr2 [lindex $list 2]
    set monatnr $monatnr2
    set jahr2 [lindex $list 3]
    set jahr $jahr2
    set monatnr3 [lindex $list 4]
    set jahr3 [lindex $list 5]

    set jahrliste [list "" $jahr1 $jahr2 $jahr3]
    set monatliste [list "" $monatnr1 $monatnr2 $monatnr3]
    set monat1 [lindex $Monatsnamenliste $monatnr1]
    set monat2 [lindex $Monatsnamenliste $monatnr2]
    set monat3 [lindex $Monatsnamenliste $monatnr3]
    set list [lreplace $list 0 5]

    set lauf 0
    set lauf2 0
    set markz 0
    set marks 0
    set markflag 0
    set markf 0
    set markiert 0

    #.tag.datum configure -text $datum
    .monate.1.n1.name1 configure -text $monat1
    .monate.1.n1.jahr1 configure -text $jahr1
    .monate.2.n2.name2 configure -text $monat2
    .monate.2.n2.jahr2 configure -text $jahr2
    .monate.3.n3.name3 configure -text $monat3
    .monate.3.n3.jahr3 configure -text $jahr3

    for {set fenster 1} {$fenster < 4} {incr fenster 1} {
        for {set kw 1} {$kw < 7} {incr kw 1} {
            set variable [lindex $list $lauf]
            if {$variable == "0"} {
                set status "disabled"
                set variable " "
            } else {
                set status "normal"
            }
            .monate.$fenster.u$fenster.k.$kw configure -text $variable -state $status -command "{zur_wochenuebersicht} $kw $variable [lindex $jahrliste $fenster]"
	    bind .monate.$fenster.u$fenster.k.$kw <Button-3> "{monatsuebersicht_markieren} $kw 0 0 $fenster $status"
            incr lauf 1
        }
        for {set tagspalte 1} {$tagspalte < 8} {incr tagspalte 1} {
            for {set tag 1} {$tag < 7} {incr tag 1} {
                set variable [lindex $list $lauf]
                if {$variable == "0"} {
                    set status "disabled"
                    set variable " "
                } else {
                    set status "normal"
                }
                set monat [lindex $monatliste $fenster]
                set jahr [lindex $jahrliste $fenster]
                incr lauf 1
                set vordergrund [lindex $list $lauf]
                incr lauf 1
                set hintergrund [lindex $list $lauf]
                incr lauf 1
                set vordergrund [vg $vordergrund]
                set hintergrund [hg $hintergrund]
                .monate.$fenster.u$fenster.u.$tagspalte.$tag configure -text $variable -state $status -fg $vordergrund -bg $hintergrund -command "{tagesuebersicht} $variable.$monat.$jahr"
		bind .monate.$fenster.u$fenster.u.$tagspalte.$tag <Button-3> "{monatsuebersicht_markieren} $tag $tagspalte 1 $fenster $status"
            }
        }
    }
set jahr [lindex $jahrliste 2]
}

proc loesche_markierung {} {
    global markiert markz marks markflag markf
    if {$markiert == "1"} {
	if {$markflag == "1"} {
	    .monate.$markf.u$markf.u.$marks.$markz configure -relief flat
	    set markiert 0
	} {
	    .monate.$markf.u$markf.k.$markz configure -relief flat
	    set markiert 0
	}
    }
}

proc monatsuebersicht_markieren {zeile spalte flag f stat} {
    if {$stat == "normal"} {
        global markiert markz marks markflag markf
        set listealt [list $markz $marks $markflag $markf]
        set listeneu [list $zeile $spalte $flag $f]
        if {$markiert == "0"} {
            if {$flag == "0"} {
              .monate.$f.u$f.k.$zeile configure -relief groove
              set markiert 1
              set markz $zeile
              set marks $spalte
              set markflag $flag
              set markf $f
            } else {
              .monate.$f.u$f.u.$spalte.$zeile configure -relief groove
              set markiert 1
              set markz $zeile
              set marks $spalte
              set markflag $flag
              set markf $f
            }
        } else {
            if {$flag == "0"} {
                if {$listealt == $listeneu} {
                    .monate.$f.u$f.k.$zeile configure -relief flat
                    set markiert 0
                } else {
                    if {$markflag == "0"} {
                      .monate.$markf.u$markf.k.$markz configure -relief flat
                    } else {
                      .monate.$markf.u$markf.u.$marks.$markz configure -relief flat
                    }
                    set markz $zeile
                    set marks $spalte
                    set markflag $flag
                    set markf $f
                    .monate.$f.u$f.k.$zeile configure -relief groove
                }
            } else {
                if {$listealt == $listeneu} {
                    .monate.$f.u$f.u.$spalte.$zeile configure -relief flat
                    set markiert 0
                } else {
                    if {$markflag == "0"} {
                      .monate.$markf.u$markf.k.$markz configure -relief flat
                    } else {
                      .monate.$markf.u$markf.u.$marks.$markz configure -relief flat
                    }
                    set markz $zeile
                    set marks $spalte
                    set markflag $flag
                    set markf $f
                    .monate.$f.u$f.u.$spalte.$zeile configure -relief groove
                }
            }
        }
    }
}

proc zur_wochenuebersicht {kw woche jahr} {
    if {$woche == "1" && $kw > 2} {
	incr jahr 1
    }
    if {$kw == "1" && $woche > 51} {
	incr jahr -1
    }
    wochenuebersicht $woche $jahr
}

proc heute_monat {} {
    global monatnr jahr Monatsnamenliste
    set datum [.tag.datum cget -text]
    set datum [split $datum ","]
    set datum [lindex $datum 1]
    set datum [split $datum " "]
    set monatname [lindex $datum 2]
    set jahr [lindex $datum 3]
    set monatnr [lsearch -exact $Monatsnamenliste $monatname]
    update_monatsuebersicht
}

# Ada init:
# ->
# <- String "Tag:Monat:Jahr"

init


# Ada daten_monat:
# -> String "Tag:Monat:Jahr"
# <- String "Heutiges_Datum:monat_links:jahr_links:monat_mitte:jahr_mitte:
#            monat_rechts:jahr_rechts:<KWs monat_links>:<Tage monat_links>:
#            ...:<Tage monat_rechts>
# Format <Tage>: spaltenweise Nummer:Farbe
set daten [daten_monat $monatnr $jahr]

# Variablen
set list [split $daten @]
set list [lreplace $list 0 1]
set datum ""
append datum $wochentag ", " $tag ". " $monatname " " $jahr
set monatnr1 [lindex $list 0]
set jahr1 [lindex $list 1]
set monatnr2 [lindex $list 2]
set jahr2 [lindex $list 3]
set monatnr3 [lindex $list 4]
set jahr3 [lindex $list 5]
set jahrliste [list "" $jahr1 $jahr2 $jahr3]
set monatliste [list "" $monatnr1 $monatnr2 $monatnr3]
set monat1 [lindex $Monatsnamenliste $monatnr1]
set monat2 [lindex $Monatsnamenliste $monatnr2]
set monat3 [lindex $Monatsnamenliste $monatnr3]
set list [lreplace $list 0 5]

set lauf 0
set lauf2 0
set markz 0
set marks 0
set markflag 0
set markf 0
set markiert 0

# Name des Haupstfensters
wm title . Terminkalender

# nicht vergroesserbar
wm resizable . 0 0

# frame fuer Fenstername
frame .name
pack .name -side top -fill x -pady 5 -padx 5
label .name.fenster -text "Monatsuebersicht" -justify center
pack .name.fenster -side top
button .name.beenden -text "Beenden" -command exit -justify center
pack .name.beenden -side right -anchor e

# frame fuer Kopfzeile (Tagesdatum)
frame .tag
pack .tag -side top -fill x -pady 5 -padx 5
# Kopfzeile
button .tag.datum -text $datum -justify left -relief flat -command "heute_monat"
pack .tag.datum -side left

# Uebersicht

# Monatsnamen
frame .monate
pack .monate -side top -fill both -pady 5 -padx 5
frame .monate.1 -relief sunken -bd 2
frame .monate.2 -relief sunken -bd 2
frame .monate.3 -relief sunken -bd 2
pack .monate.1 .monate.2 .monate.3 -side left -fill both -padx 5
frame .monate.1.n1
frame .monate.2.n2
frame .monate.3.n3
pack .monate.1.n1 .monate.2.n2 .monate.3.n3 -side top
label .monate.1.n1.name1 -text $monat1 -justify center -pady 5
label .monate.1.n1.jahr1 -text $jahr1 -justify center -pady 4
pack .monate.1.n1.name1 .monate.1.n1.jahr1 -side left -expand yes
label .monate.2.n2.name2 -text $monat2 -justify center -pady 5
label .monate.2.n2.jahr2 -text $jahr2 -justify center -pady 5
pack .monate.2.n2.name2 .monate.2.n2.jahr2 -side left -expand yes
label .monate.3.n3.name3 -text $monat3 -justify center -pady 5
label .monate.3.n3.jahr3 -text $jahr3 -justify center -pady 5
pack .monate.3.n3.name3 .monate.3.n3.jahr3 -side left -expand yes
frame .monate.1.u1
frame .monate.2.u2
frame .monate.3.u3
pack .monate.1.u1 .monate.2.u2 .monate.3.u3 -side top -expand yes

# eigentliche Monatsuebersicht, drei Monate nebeneinander
# 3x2 Unterfenster (1x KWs, 1x Monat)
for {set fenster 1} {$fenster < 4} {incr fenster 1} {
    frame .monate.$fenster.u$fenster.k
    pack  .monate.$fenster.u$fenster.k -side left -fill y -padx 2
    label .monate.$fenster.u$fenster.k.kw -text "KW" -justify center
    pack .monate.$fenster.u$fenster.k.kw -side top -pady 5 -padx 30

    # 6 Buttons untereinander
    for {set kw 1} {$kw < 7} {incr kw 1} {
        set variable [lindex $list $lauf]
        if {$variable == "0"} {
            set status "disabled"
            set variable " "
        } else {
            set status "normal"
        }
        set jahr [lindex $jahrliste $fenster]
        button .monate.$fenster.u$fenster.k.$kw -text $variable -justify center -relief flat -state $status -command "{zur_wochenuebersicht} $kw $variable [lindex $jahrliste $fenster]" -disabledforeground [lindex $VordergrundFarben 0]
        bind .monate.$fenster.u$fenster.k.$kw <Button-3> "{monatsuebersicht_markieren} $kw 0 0 $fenster $status"
        incr lauf 1
        pack .monate.$fenster.u$fenster.k.$kw -side top -padx 0
    }
    frame .monate.$fenster.u$fenster.u
    pack .monate.$fenster.u$fenster.u -side left -fill y

    # Monat: 7 Spalten (Mo-So)
    for {set tagspalte 1} {$tagspalte < 8} {incr tagspalte 1} {
        frame .monate.$fenster.u$fenster.u.$tagspalte
        pack .monate.$fenster.u$fenster.u.$tagspalte -side left -fill y
        set variable [lindex $Tagnamenliste $lauf2]
        label .monate.$fenster.u$fenster.u.$tagspalte.tagname -text $variable -justify center
        if {$variable == "Sa" || $variable == "So"} {
            .monate.$fenster.u$fenster.u.$tagspalte.tagname configure -fg [lindex $VordergrundFarben 1]
        }
        incr lauf2 1
        pack .monate.$fenster.u$fenster.u.$tagspalte.tagname -side top -pady 5 -padx 0 -anchor n
        # Monat: 6 Buttons pro Spalte
        for {set tag 1} {$tag < 7} {incr tag 1} {
            set variable [lindex $list $lauf]
            if {$variable == "0"} {
                set status "disabled"
                set variable " "
            } else {
                set status "normal"
            }
            set monat [lindex $monatliste $fenster]
            set jahr [lindex $jahrliste $fenster]
            button .monate.$fenster.u$fenster.u.$tagspalte.$tag -text $variable -justify center -relief flat -padx 5 -state $status -command "{tagesuebersicht} $variable.$monat.$jahr"
            bind .monate.$fenster.u$fenster.u.$tagspalte.$tag <Button-3> "{monatsuebersicht_markieren} $tag $tagspalte 1 $fenster $status"
            incr lauf 1
            pack .monate.$fenster.u$fenster.u.$tagspalte.$tag -side top -fill x -padx 0
            set vordergrund [lindex $list $lauf]
            incr lauf 1
            set hintergrund [lindex $list $lauf]
            incr lauf 1
            set vordergrund [vg $vordergrund]
            set hintergrund [hg $hintergrund]
            .monate.$fenster.u$fenster.u.$tagspalte.$tag configure -fg $vordergrund -disabledforeground $vordergrund
            .monate.$fenster.u$fenster.u.$tagspalte.$tag configure -bg $hintergrund
        }
    }
    set lauf2 0
set jahr [lindex $jahrliste 2]
}

# Legende
frame .legende
pack .legende -side top -fill both -pady 20 -padx 5
button .legende.abm -text "  " -justify center -relief flat -bg [lindex $HintergrundFarben 1] -state disabled
pack .legende.abm -side left
label .legende.abmt -text "Abwesenheit"
pack .legende.abmt -side left -padx 5
button .legende.ter -text "  " -justify center -relief flat -bg [lindex $HintergrundFarben 2] -state disabled
pack .legende.ter -side left
label .legende.tert -text "Termin"
pack .legende.tert -side left -padx 5
button .legende.mar -text "  " -justify center -state disabled -bd 2 -relief groove
pack .legende.mar -side left
label .legende.mart -text "Markierte(r) Woche/Tag"
pack .legende.mart -side left -padx 5
button .legende.fei -text "20" -justify center -relief flat -state disabled -disabledforeground [lindex $VordergrundFarben 1]
pack .legende.fei -side left
label .legende.feit -text "Feiertag/Wochenende"
pack .legende.feit -side left -padx 5

# Buttons
frame .buttons
pack .buttons -side top -fill both -padx 5
button .buttons.1 -text "Termin eintragen" -command "termin_eintragen" -justify center
pack .buttons.1 -expand yes -pady 1 -side left -anchor w -fill x
button .buttons.2 -text "Periodischen Termin eintragen" -command "periodischen_termin_eintragen" -justify center
button .buttons.3 -text "Termin suchen" -command "termin_suchen" -justify center
button .buttons.4 -text "Gehe zu" -command "gehe_zu" -justify center
pack .buttons.2 .buttons.3 .buttons.4 -expand yes -pady 1 -side left -fill x
button .buttons.5 -text "Periodische Termine" -command "periodische_termine" -justify center
pack .buttons.5 -expand yes -pady 1 -side left -anchor e -fill x



frame .buttons2
pack .buttons2 -side bottom -fill both -padx 5
button .buttons2.1 -text "Vorheriger Monat" -command "vorheriger_monat" -justify center
pack .buttons2.1 -expand yes -pady 1 -side left -anchor w -fill x
button .buttons2.2 -text "Abwesenheitsmarkierung setzen" -command "abwesenheitsmarkierung_setzen" -justify center
button .buttons2.3 -text "Abwesenheitsmarkierung loeschen" -command "abwesenheitsmarkierung_loeschen" -justify center
pack .buttons2.2 .buttons2.3 -expand yes -pady 1 -side left -fill x
button .buttons2.4 -text "Naechster Monat" -command "naechster_monat" -justify center
pack .buttons2.4 -expand yes -pady 1 -side left -anchor e -fill x

for {set button 1} {$button < 6} {incr button 1} {
    .buttons.$button configure -disabledforeground [lindex $VordergrundFarben 0]
}
for {set button 1} {$button < 5} {incr button 1} {
    .buttons2.$button configure -disabledforeground [lindex $VordergrundFarben 0]
}
